import java.io.InputStream;
import java.io.IOException;
import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.util.Properties;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.sql.*;
import javax.swing.*;
import javax.swing.border.*;

public class HelloJDBC2 extends JApplet
implements ActionListener {
    Connection conn;
    PreparedStatement pstmt;
    DefaultListModel namesListModel;
    JList namesList;
    JButton execButton;
    JScrollPane scrollPane;
    JPanel displayPanel;

    public HelloJDBC2() {
        Container panel;
        JLabel nameLabel;
        GridBagLayout gbl = new GridBagLayout();
        GridBagConstraints gbc = new GridBagConstraints();
        Insets defInsets, tmpInsets;
        defInsets = gbc.insets;
        tmpInsets = new Insets(5, 5, 5, 5);
        //
        gbc.insets = tmpInsets;
        panel = getContentPane();
        panel.setLayout(gbl);
        nameLabel = new JLabel("O:");
        place(gbc, panel, nameLabel, 0, 0, 1, 1, 1.0, 0.0,
              gbc.WEST, gbc.NONE);
        namesListModel = new DefaultListModel();
        namesList = new JList(namesListModel);
        namesList.setVisibleRowCount(5);
        namesList.setBorder(new BevelBorder(BevelBorder.LOWERED));
        place(gbc, panel, namesList, 0, 1, 1, 4, 1.0, 0.0,
              gbc.WEST, gbc.BOTH);
        execButton = new JButton("");
        place(gbc, panel, execButton, 1, 1, 1, 4, 0.0, 0.0,
              gbc.CENTER, gbc.NONE);
        displayPanel = new JPanel();
        displayPanel.setLayout(
            new BoxLayout(displayPanel, BoxLayout.Y_AXIS));
        displayPanel.setAlignmentY(displayPanel.TOP_ALIGNMENT);
        scrollPane = new JScrollPane(displayPanel);
        place(gbc, panel, scrollPane, 0, 5, 2, 4, 1.0, 1.0,
              gbc.CENTER, gbc.BOTH);
        //
        panel.validate();
        execButton.addActionListener(this);
    }

    public void init() {
        // DB ڑ
        try {
            Properties props = new Properties();
            props.put("user", "hellouser");
            props.put("password", "hellopwd");
            props.put("CHARSET", "eucjis");
            Class.forName("com.sybase.jdbc.SybDriver");
            conn = DriverManager.getConnection(
                "jdbc:sybase:Tds:sprigan:1030", props);
            pstmt = conn.prepareStatement(
                "SELECT name, age, birth_date, comment, face "+
                "FROM hello WHERE name = ?");
        } catch (Exception ex) {
            showError("DB ڑI[vł܂B");
            ex.printStackTrace();
            setEnabledAll(false);
            return;
        }
        // ꗗ擾 & Xg\
        try {
            Statement stmt;
            ResultSet rs;
            String name;
            stmt = conn.createStatement();
            rs = stmt.executeQuery("SELECT name FROM hello");
            while (rs.next()) {
                name = rs.getString("name").trim();
                namesListModel.addElement(name);
            }
            rs.close();
            stmt.close();
        } catch (SQLException ex) {
            showError("f[^̌Ɏs܂B");
            ex.printStackTrace();
            setEnabledAll(false);
        }
    }

    public void destroy() {
        // DB ڑp
        if (conn != null) {
            try {
                conn.close();
            } catch (SQLException ex) {
                // ł͖
            }
        }
    }

    public void actionPerformed(ActionEvent ev) {
        displayPanel.removeAll();
        displayPersonalData(namesList.getSelectedValues());
        scrollPane.repaint();
        scrollPane.revalidate();
    }

    void displayPersonalData(Object[] values) {
        try {
            ResultSet rs;
            String name, comment;
            int age;
            Date birth_date;
            InputStream faceSource;
            byte[] face = new byte[8192];
            SimpleDateFormat dateFormat;
            ImageIcon faceImage;
            JPanel personPanel, dataPanel;
            JLabel faceLabel;
            dateFormat = new SimpleDateFormat("yyyy/MM/dd");
            for (int i = 0; i < values.length; i++) {
                name = values[i].toString();
                pstmt.setString(1, name);
                rs = pstmt.executeQuery();
                if (!rs.next()) {
                    // Yf[^
                    rs.close();
                    continue;
                }
                age = rs.getInt("age");
                birth_date = rs.getDate("birth_date");
                comment = rs.getString("comment");
                faceSource = rs.getBinaryStream("face");
                if (faceSource != null) {
                    try {
                        faceSource.read(face);
                        faceImage = new ImageIcon(face);
                    } catch (IOException ex) {
                        faceImage = null;
                    }
                } else {
                    faceImage = null;
                }
                //
                personPanel = new JPanel();
                personPanel.setLayout(
                    new BoxLayout(personPanel, BoxLayout.X_AXIS));
                personPanel.setAlignmentX(personPanel.LEFT_ALIGNMENT);
                dataPanel = new JPanel();
                dataPanel.setLayout(
                    new BoxLayout(dataPanel, BoxLayout.Y_AXIS));
                //
                if (faceImage != null) {
                    faceLabel = new JLabel(faceImage);
                } else {
                    faceLabel = new JLabel("No Image", JLabel.CENTER);
                    faceLabel.setBackground(Color.black);
                    faceLabel.setForeground(Color.white);
                    faceLabel.setOpaque(true);
                    faceLabel.setMinimumSize(new Dimension(80, 100));
                    faceLabel.setMaximumSize(new Dimension(80, 100));
                    faceLabel.setPreferredSize(new Dimension(80, 100));
                }
                personPanel.add(faceLabel);
                dataPanel.add(new JLabel("O:" + name));
                dataPanel.add(new JLabel("N:" + age));
                dataPanel.add(new JLabel("N:" +
                                         dateFormat.format(birth_date)));
                dataPanel.add(new JLabel("Rg:" + comment));
                personPanel.add(dataPanel);
                displayPanel.add(personPanel);
                // Zp[^}
                if (i+1 < values.length) {
                    displayPanel.add(new JSeparator());
                }
            }
        } catch (SQLException ex) {
            showError("lf[^̌Ɏs܂B");
            ex.printStackTrace();
            setEnabledAll(false);
        }
    }

    private void place(GridBagConstraints c, Container cn,
                       Component cmp, int x, int y, int w, int h,
                       double wx, double wy, int ac, int fl) {
        c.gridx = x;
        c.gridy = y;
        c.gridwidth = w;
        c.gridheight = h;
        c.weightx = wx;
        c.weighty = wy;
        c.anchor = ac;
        c.fill = fl;
        cn.add(cmp, c);
    }

    private void showError(String mes) {
        JOptionPane.showMessageDialog(this, mes, "ERROR",
                                      JOptionPane.ERROR_MESSAGE);
    }

    private void setEnabledAll(boolean f) {
        setEnabledAll(this, f);
    }

    private void setEnabledAll(Container cn, boolean f) {
        Component[] coms = cn.getComponents();
        for(int i = 0; i < coms.length; i++){
            coms[i].setEnabled(f);
            if (coms[i] instanceof java.awt.Container) {
                setEnabledAll((Container)coms[i], f);
            }
        }
    }
}
