/*
 * Copyright (c) 1999 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, and distribute this software for
 * NON-COMMERCIAL purposes and without fee is hereby granted
 * provided that this copyright notice appears in all copies.
 *
 */

import java.sql.Driver;

/**
 * hCoo^_CAOEW[
 * @version	1.2 99/10/12
 * @author 	Yuichi Omata, Sun Microsystems Inc.
 * @author      Tadayoshi Maekawa, Sun Microsystems K.K.
 */
public class AddDriverDialog {
    static final String[][] DriverList = {
        { "", "" },
        { "ODBC Bridge", "sun.jdbc.odbc.JdbcOdbcDriver" },
        { "Sybase jConnect", "com.sybase.jdbc.SybDriver" },
        { "WebLogic jdbcKona/Sybase", "weblogic.jdbc.dblib.Driver" },
        { "Symantec", "symantec.itools.db.jdbc.Driver" }
    };

    JDBCTerminal app;
    AddDriverDialogGUI gui;

    public AddDriverDialog(JDBCTerminal app) {
	this.app = app;
	gui = new AddDriverDialogGUI(app.getMainFrame().gui, this);
    }

    public JDBCTerminal getApp() {
	return app;
    }

    public AddDriverDialogGUI getGUI() {
        return gui;
    }

    public void registerDriver(String driverName) {
        try {
            Class.forName(driverName);
            app.getMainFrame().updateDriverList();
        } catch (ClassNotFoundException ex) {
            gui.setVisible(false);
            JDBCTerminal.showMessage(
                "Can not find driver " + driverName,
                app.getMainFrame().gui);
        }
    }

    public void setVisible(boolean b) {
	gui.setVisible(b);
    }

}
