/*
 * Copyright (c) 199i Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, and distribute this software for
 * NON-COMMERCIAL purposes and without fee is hereby granted
 * provided that this copyright notice appears in all copies.
 *
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * hCoo^_CAO GUI
 * @version	1.2 99/10/12
 * @author 	Yuichi Omata, Sun Microsystems Inc.
 * @author      Tadayoshi Maekawa, Sun Microsystems K.K.
 */
public class AddDriverDialogGUI extends JDialog implements WindowListener {

//    AddDriverDialog module;
    JLabel driverNameLabel;
    JTextField driverNameTextField;
    JComboBox driverChoice;
    JButton registerButton;
    JButton cancelButton;

    public AddDriverDialogGUI(Frame mainFrame, AddDriverDialog module) {
        super(mainFrame);
	addWindowListener(this);
	setTitle("JDBCTerminal: Add Driver");

        Container pane = getContentPane();
	GridBagLayout gbl = new GridBagLayout();
	gbl.columnWidths = new int[] {14,14,14,14,14};
	gbl.rowHeights =  new int[] {14,14,14,14,14,14,14,14};
	gbl.columnWeights = new double[] {0.0,0.0,0.0,0.0,0.0};
	gbl.rowWeights = new double[] {0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0};
	pane.setLayout(gbl);
	GridBagConstraints gbc = new GridBagConstraints();
	
        // create driver name Label
        driverNameLabel = new JLabel("Driver Name:");
        gbc.gridx = 1;
        gbc.gridy = 1;
        gbc.anchor = GridBagConstraints.WEST;
        gbl.setConstraints(driverNameLabel, gbc);
        pane.add(driverNameLabel);

        // create driver name TextField
        driverNameTextField = new JTextField(35);
        gbc.gridy++;
        gbc.gridwidth = 3;
        gbl.setConstraints(driverNameTextField, gbc);
        pane.add(driverNameTextField);

	// create driverChoice
        driverChoice = new JComboBox();
	gbc.gridy += 2;
	gbc.gridwidth = 3;
	gbc.anchor = GridBagConstraints.WEST;
	gbl.setConstraints(driverChoice, gbc);
        for (int i = 0; i < module.DriverList.length; i++) {
            driverChoice.addItem(module.DriverList[i][0]);
        }
        driverChoice.setSelectedItem("");
	driverChoice.addActionListener(new AddDriverDialogCommand(AddDriverDialogCommand.Drivers, module));
	pane.add(driverChoice);

        // create register Button
	registerButton = new JButton("Register");
	gbc.gridx = 1;
	gbc.gridy += 2;
	gbl.setConstraints(registerButton, gbc);
	registerButton.addActionListener(new AddDriverDialogCommand(AddDriverDialogCommand.Register, module));
	pane.add(registerButton);

	cancelButton = new JButton("Cancel");
	gbc.gridx += 2;
	gbl.setConstraints(cancelButton, gbc);
	cancelButton.addActionListener(new AddDriverDialogCommand(AddDriverDialogCommand.Cancel, module));
	pane.add(cancelButton);

        pack();
    }

    public void windowActivated(WindowEvent ev) {}
    public void windowClosed(WindowEvent ev) {}
    public void windowClosing(WindowEvent ev) {
        setVisible(false);
    }
    public void windowDeactivated(WindowEvent ev) {}
    public void windowDeiconified(WindowEvent ev) {}
    public void windowIconified(WindowEvent ev) {}
    public void windowOpened(WindowEvent ev) {}

}
