/*
 * Copyright (c) 1999 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, and distribute this software for
 * NON-COMMERCIAL purposes and without fee is hereby granted
 * provided that this copyright notice appears in all copies.
 *
 */

import java.sql.*;
import java.awt.*;
import java.awt.event.*;
import java.io.PrintWriter;
import javax.swing.*;

/**
 * JDBCTerminal OEt[ GUI
 * @version	1.1 99/10/05
 * @author 	Yuichi Omata, Sun Microsystems Inc.
 * @author      Tadayoshi Maekawa, Sun Microsystems K.K.
 */
public class LogFrameGUI extends JFrame implements WindowListener {
    JTextArea logArea;
    PrintWriter writer;

    public LogFrameGUI(){
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
	addWindowListener(this);
        //
	setTitle("JDBCTerminal: Log Window");
	setSize(new Dimension(400, 300));
	setLocation(new Point(100, 100));
        Container pane = getContentPane();
	pane.setLayout(new BorderLayout());
        //
        JScrollPane logPane;
	logArea = new JTextArea();
	logArea.setEditable(false);
        writer = new PrintWriter(new TextComponentWriter(logArea));
        logPane = new JScrollPane(
            logArea,
            JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
            JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
	pane.add(logPane, "Center");
    }


    public PrintWriter getLogWriter() {
        return writer;
    }

    public void windowClosing(WindowEvent ev){
	setVisible(false);
        DriverManager.setLogWriter(null);
    }

    public void windowActivated(WindowEvent ev) {}
    public void windowClosed(WindowEvent ev) {}
    public void windowDeactivated(WindowEvent ev) {}
    public void windowDeiconified(WindowEvent ev) {}
    public void windowIconified(WindowEvent ev) {}
    public void windowOpened(WindowEvent ev) {}
}
