/*
 * Copyright (c) 1999 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, and distribute this software for
 * NON-COMMERCIAL purposes and without fee is hereby granted
 * provided that this copyright notice appears in all copies.
 *
 */

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import java.io.PrintWriter;

/**
 * @version     1.3 99/10/13
 * @author      Yuichi Omata, Sun Microsystems Inc.
 * @author      Tadayoshi Maekawa, Sun Microsystems K.K.
 */
public class LoginDialog extends JDialog implements ActionListener {

    private Properties prop;
    private JLabel idLabel;
    private JTextField idTextField;
    private JLabel pwLabel;
    private JTextField pwTextField;
    private JButton loginButton;
    private JButton cancelButton;
    private JButton propertyButton;

    /**
     *
     */
    public LoginDialog(Frame parent) {
        super(parent, true);

        setTitle("JDBCTerminal: Login");
        Container pane = getContentPane();
        GridBagLayout gbl = new GridBagLayout();
        gbl.columnWidths = new int[] {14,14,14,14,14,14};
        gbl.rowHeights =  new int[] {14,14,14,14,14,14,14,14,14};
        gbl.columnWeights = new double[] {0.0,0.0,0.0,0.0,0.0,0.0};
        gbl.rowWeights = new double[] {0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0};
        pane.setLayout(gbl);
        GridBagConstraints gbc = new GridBagConstraints();

        // idLabel
        idLabel = new JLabel("login ID:");
        gbc.gridx = 1;
        gbc.gridy = 1;
        gbc.gridwidth = 2;
        gbc.anchor = GridBagConstraints.WEST;
        gbl.setConstraints(idLabel, gbc);
        pane.add(idLabel);

        // idTextField
        idTextField = new JTextField(15);
        gbc.gridy = 2;
        gbl.setConstraints(idTextField, gbc);
        pane.add(idTextField);

        // pwLabel
        pwLabel = new JLabel("Password:");
        gbc.gridy = 4;
        gbl.setConstraints(pwLabel, gbc);
        pane.add(pwLabel);

        // pwTextField
        pwTextField = new JPasswordField(15);
        gbc.gridy = 5;
        gbl.setConstraints(pwTextField, gbc);
        pane.add(pwTextField);

        // loginButton
        loginButton = new JButton("Login");
        gbc.gridy = 7;
        gbc.gridwidth = 1;
        gbc.anchor = GridBagConstraints.CENTER;
        gbl.setConstraints(loginButton, gbc);
        pane.add(loginButton);
        loginButton.addActionListener(this);

        // cancelButton
        cancelButton = new JButton("Cancel");
        gbc.gridx = 2;
        gbl.setConstraints(cancelButton, gbc);
        pane.add(cancelButton);
        cancelButton.addActionListener(this);

        // propertyButton
        propertyButton = new JButton("Property...");
        gbc.gridx = 4;
        gbl.setConstraints(propertyButton, gbc);
        pane.add(propertyButton);
        propertyButton.addActionListener(this);
        
        pack();
    }

    /**
     * OCE_CAÕANVECxgEnh
     * OC(OCƃpX[h̑g)vpeB
     * Ƃč쐬B
     */
    public void actionPerformed(ActionEvent ev) {
        if (ev.getSource() == loginButton){
            if (prop == null)
                prop = new Properties();
            prop.put("user", idTextField.getText());
            prop.put("password", pwTextField.getText());
            setVisible(false);
        } if (ev.getSource() == propertyButton){
            PropertyEditor pe;
            pe = new PropertyEditor((Frame)getParent(), true, prop);
            prop = pe.getProperties();
        } else {
            setVisible(false);
        }
    }

    /**
     * OCi[vpeBԂB
     * @return OCvpeB
     */
    public Properties getProp() {
        return prop;
    }
}
