/*
 * Copyright (c) 1999 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, and distribute this software for
 * NON-COMMERCIAL purposes and without fee is hereby granted
 * provided that this copyright notice appears in all copies.
 *
 */

import java.awt.*;
import java.awt.event.*;
//import java.util.*;
import java.io.*;
import java.text.SimpleDateFormat;
import java.text.ParseException;
import java.sql.Date;
import javax.swing.*;

/**
 * hello e[upeiXEAvP[V GUI 񋟂B
 *
 * @author Yuichi Omata, Tadayoshi Maekawa, Sun Microsystems K.K.
 * @version 1.2 99/09/24
 */
class ImageStoreUI extends JFrame implements ActionListener {
    /**
     * AvP[V{́B
     */
    ImageStore application;

    /**
     * GUI IuWFNgB
     */
    JTextField nameField;
    JTextField ageField;
    JTextField birthDateField;
    JTextField commentField;
    JLabel faceLabel;
    JToggleButton retrieveButton;
    JToggleButton updateButton;
    JToggleButton newButton;
    JToggleButton deleteButton;
    JButton executeButton;
    JButton loadImageButton;

    JMenuBar menu;
    JMenu connectMenu;
    JMenuItem connectItem;
    JMenuItem cutOffItem;
    JMenuItem propertyItem;
    JMenuItem exitItem;

    JFileChooser loadDialog;

    /**
     * t\ptH[}b^B
     */
    SimpleDateFormat dateForm;

    /**
     * \̉摜f[^B
     */
    byte[] faceData;

    /**
     * RXgN^B
     * @param ap AvP[V{
     */
    public ImageStoreUI(ImageStore ap) {
        super("ImageStore");
        setDefaultCloseOperation(DISPOSE_ON_CLOSE);
        application = ap;
        dateForm = new SimpleDateFormat("yyyy/MM/dd");
        //
        GridBagLayout gbl = new GridBagLayout();
        GridBagConstraints gbc = new GridBagConstraints();
        Container pane = getContentPane();
        JPanel modePanel = new JPanel();
        ButtonGroup modeGroup = new ButtonGroup();
        pane.setLayout(gbl);
        //
        gbc.insets = new Insets(3, 5, 3, 5);
        place(gbc, pane, new JLabel("O:", JLabel.RIGHT),
              1, 0, 1, 1, 0.0, 0.0, gbc.EAST, gbc.NONE);
        nameField = new JTextField(20);
        place(gbc, pane, nameField,
              2, 0, 2, 1, 0.0, 0.0, gbc.WEST, gbc.NONE);
        place(gbc, pane, new JLabel("N:", JLabel.RIGHT),
              1, 1, 1, 1, 0.0, 0.0, gbc.EAST, gbc.NONE);
        ageField = new JTextField(5);
        place(gbc, pane, ageField,
              2, 1, 1, 1, 0.0, 0.0, gbc.WEST, gbc.NONE);
        place(gbc, pane, new JLabel("a:", JLabel.RIGHT),
              1, 2, 1, 1, 0.0, 0.0, gbc.EAST, gbc.NONE);
        birthDateField = new JTextField(10);
        place(gbc, pane, birthDateField,
              2, 2, 1, 1, 0.0, 0.0, gbc.WEST, gbc.NONE);
        place(gbc, pane, new JLabel("Rg:", JLabel.RIGHT),
              1, 3, 1, 1, 0.0, 0.0, gbc.EAST, gbc.NONE);
        commentField = new JTextField(32);
        place(gbc, pane, commentField,
              2, 3, 4, 1, 0.0, 0.0, gbc.WEST, gbc.NONE);
        faceLabel = new JLabel("No Image", JLabel.CENTER);
        faceLabel.setBackground(Color.black);
        faceLabel.setForeground(Color.white);
        faceLabel.setOpaque(true);
        faceLabel.setMinimumSize(new Dimension(80, 100));
        faceLabel.setMaximumSize(faceLabel.getMinimumSize());
        faceLabel.setPreferredSize(faceLabel.getMinimumSize());
        place(gbc, pane, faceLabel,
              4, 0, 1, 3, 0.0, 0.0, gbc.CENTER, gbc.NONE);
        retrieveButton = new JToggleButton("", true);
        modeGroup.add(retrieveButton);
        modePanel.add(retrieveButton);
        updateButton = new JToggleButton("XV", false);
        modeGroup.add(updateButton);
        modePanel.add(updateButton);
        newButton = new JToggleButton("VK", false);
        modeGroup.add(newButton);
        modePanel.add(newButton);
        deleteButton = new JToggleButton("폜", false);
        modeGroup.add(deleteButton);
        modePanel.add(deleteButton);
        place(gbc, pane, modePanel,
              0, 4, 4, 1, 0.0, 0.0, gbc.CENTER, gbc.NONE);
        executeButton = new JButton("");
        place(gbc, pane, executeButton,
              4, 4, 1, 1, 0.0, 0.0, gbc.CENTER, gbc.NONE);
        loadImageButton = new JButton("摜[h...");
        place(gbc, pane, loadImageButton,
              5, 4, 1, 1, 0.0, 0.0, gbc.CENTER, gbc.NONE);
        // j[o[̒ǉ
        menu = new JMenuBar();
        connectMenu = new JMenu("ڑ");
        connectItem = new JMenuItem("ڑ...");
        cutOffItem = new JMenuItem("ؒf");
        propertyItem = new JMenuItem("vpeB...");
        exitItem = new JMenuItem("I");
        connectMenu.add(connectItem);
        connectMenu.add(cutOffItem);
        connectMenu.add(propertyItem);
        connectMenu.add(new JSeparator());
        connectMenu.add(exitItem);
        menu.add(connectMenu);
        setJMenuBar(menu);
        //
        retrieveButton.addActionListener(this);
        updateButton.addActionListener(this);
        newButton.addActionListener(this);
        deleteButton.addActionListener(this);
        executeButton.addActionListener(this);
        loadImageButton.addActionListener(this);
        connectItem.addActionListener(this);
        cutOffItem.addActionListener(this);
        propertyItem.addActionListener(this);
        exitItem.addActionListener(this);
        //
        pack();
    }

    /**
     * ActionEvent:action-performed B
     * @param ev Cxg
     */
    public void actionPerformed(ActionEvent ev) {
        Object src = ev.getSource();
        if (src == retrieveButton) {
            application.setupMode(application.MODE_RETRIEVE);
        } else if (src == updateButton) {
            application.setupMode(application.MODE_UPDATE);
        } else if (src == newButton) {
            application.setupMode(application.MODE_NEW);
        } else if (src == deleteButton) {
            application.setupMode(application.MODE_DELETE);
        } else if (src == connectItem) {
            application.getDBConnection();
        } else if (src == cutOffItem) {
            application.dropDBConnection();
        } else if (src == propertyItem) {
            application.setDBProperty();
        } else if (src == exitItem) {
            application.stop();
        } else if (src == executeButton) {
            try {
                application.executeSQL();
            } catch (Exception ex) {
                ex.printStackTrace();
                showError(ex.getMessage());
            }
        } else if (src == loadImageButton) {
            try {
                loadImage();
            } catch (Exception ex) {
                ex.printStackTrace();
                showError(ex.getMessage());
            }
        }
    }

    /**
     * AvP[V샂[hɑΉ GUI ̕ҏW/sݒ肷B
     * @param md 샂[h
     */
    protected void setupOperatable(int md) {
        boolean nm, ag, bd, cm, ex, li;
        String exl;
        switch (md) {
        case application.MODE_UPDATE:
            nm = false;
            ag = bd = cm = ex = li = true;
            exl = "XV";
            break;
        case application.MODE_NEW:
            nm = ag = bd = cm = ex = li = true;
            exl = "o^";
            break;
        case application.MODE_DELETE:
            nm = ag = bd = cm = li = false;
            ex = true;
            exl = "폜";
            break;
        case application.MODE_RETRIEVE:
        default:
            nm = ex = true;
            ag = bd = cm = li = false;
            exl = "";
        }
        nameField.setEditable(nm);
        ageField.setEditable(ag);
        birthDateField.setEditable(bd);
        commentField.setEditable(cm);
        executeButton.setText(exl);
        executeButton.setEnabled(ex);
        loadImageButton.setEnabled(li);
    }
            
    /**
     * AvP[V샂[hɑΉ GUI ̃f[^擾B
     * @param md 샂[h
     * @exception InputMissException ͌肪ꍇ
     */
    protected HelloData getHelloData(int md) throws InputMissException {
        String tmp, nm, cm;
        int ag;
        Date bd;
        byte[] fc;
        HelloData ret;
        nm = nameField.getText().trim();
        if (nm.length() < 1) {
            throw new InputMissException(
                "OtB[hłB");
        }
        switch (md) {
        case application.MODE_NEW:
        case application.MODE_UPDATE:
            tmp = ageField.getText().trim();
            try {
                ag = Integer.parseInt(tmp);
            } catch (NumberFormatException ex) {
                throw new InputMissException(
                    "NtB[hɌ肪܂B");
            }
            tmp = birthDateField.getText().trim();
            try {
                bd = new Date(dateForm.parse(tmp).getTime());
            } catch (ParseException ex) {
                throw new InputMissException(
                    "atB[hɌ肪܂B");
            }
            cm = commentField.getText().trim();
            fc = faceData;
            ret = new HelloData(nm, ag, bd, cm, fc);
            break;
        case application.MODE_DELETE:
        case application.MODE_RETRIEVE:
        default:
            ret = new HelloData(nm, -1, null, null, null);
        }
        return ret;
    }

    /**
     * GUI Ƀf[^\B
     * @param dt f[^
     */
    protected void displayHelloData(HelloData dt) {
        String nm, ag, bd, cm;
        byte[] fc;
        if (dt == null) {
            nm = ag = bd = cm = "";
            fc = null;
        } else {
            nm = dt.name;
            ag = (dt.age < 0) ? "" : String.valueOf(dt.age);
            bd = (dt.birthDate == null) ?
                "" : dateForm.format(dt.birthDate);
            cm = (dt.comment == null) ? "" : dt.comment;
            fc = dt.face;
        }
        nameField.setText(nm);
        ageField.setText(ag);
        birthDateField.setText(bd);
        commentField.setText(cm);
        faceData = fc;
        displayFace(faceData);
        validate();
    }

    /**
     * 摜f[^[hA\B
     * @exception LoadImageException 摜f[^̓ǂݍ݂Ɏsꍇ
     */
    protected void loadImage()
    throws LoadImageException {
        if (loadDialog == null) {
            // NfBNgƃfBNgɂ
            loadDialog = new JFileChooser(System.getProperty("user.dir"));
            loadDialog.setFileSelectionMode(loadDialog.FILES_ONLY);
        }
        File file;
        loadDialog.setSelectedFile(null);
        loadDialog.showOpenDialog(this);
        file = loadDialog.getSelectedFile();
        if (file == null) {
            return;
        }
        // 摜f[^̓ǂݍ
        byte[] dt = new byte[application.MAX_BYTES_OF_IMAGE];
        try {
            FileInputStream is = new FileInputStream(file);
            is.read(dt, 0, dt.length);
            is.close();
        } catch (IOException ex) {
            ex.printStackTrace();
            throw new LoadImageException(
                "摜t@C̓ǂݍ݂Ɏs܂B");
        }
        try {
            ImageIcon image = new ImageIcon(dt);
            if (image.getIconWidth() <= 0 || image.getIconHeight() <= 0) {
                dt = null;
            } else {
                byte[] dt2;
                int i;
                for (i = dt.length-1; i > 0 && dt[i-1] == 0x00; i--);
                dt2 = new byte[i];
                System.arraycopy(dt, 0, dt2, 0, i);
                dt = dt2;
            }
        } catch (Exception ex) {
            dt = null;
        }
        faceData = dt;
        displayFace(faceData);
    }

    /**
     * GUI Ŝ̎gp/sݒ肷B
     * @param f tO; true ȂgpB
     */
    protected void setEnabledAll(boolean f) {
        setEnabledAll(getContentPane(), f);
    }

    /**
     * w肳ꂽ GUI Rei̎gp/sݒ肷B
     * @param cn Rei
     * @param f tO
     */
    private void setEnabledAll(Container cn, boolean f) {
        Component[] coms = cn.getComponents();
        for(int i = 0; i < coms.length; i++){
            coms[i].setEnabled(f);
            if (coms[i] instanceof java.awt.Container) {
                setEnabledAll((Container)coms[i], f);
            }
        }
    }

    /**
     * GirdBagLayout zu\bhB
     */
    private void place(GridBagConstraints c, Container cn,
                       Component cmp, int x, int y, int w, int h,
                       double wx, double wy, int ac, int fl) {
        c.gridx = x;
        c.gridy = y;
        c.gridwidth = w;
        c.gridheight = h;
        c.weightx = wx;
        c.weighty = wy;
        c.anchor = ac;
        c.fill = fl;
        cn.add(cmp, c);
    }

    /**
     * 摜f[^\B
     * @param dt 摜f[^
     */
    private void displayFace(byte[] dt) {
        if (dt == null) {
            faceLabel.setIcon(null);
            faceLabel.setText("No Image");
        } else {
            faceLabel.setIcon(new ImageIcon(dt));
            faceLabel.setText(null);
        }
    }

    /**
     * G[_CAOŕ\B
     * @param mes bZ[W
     */
    private void showError(String mes) {
        JOptionPane.showMessageDialog(this, mes, "ERROR",
                                      JOptionPane.ERROR_MESSAGE);
    }
}
